GLFW: Initialization, version and error reference

GLFW

- Documentation
- Download
- Community

Loading...
Searching...
No Matches
Modules | Macros | Typedefs | Functions
Initialization, version and error reference

## Description

This is the reference documentation for initialization and termination of the library, version management and error handling. For more task-oriented information, see the Introduction to the API.

## Modules
| Error codes
| Error codes.

## Macros
#define | GLFW_TRUE 1
| One.
#define | GLFW_FALSE 0
| Zero.
#define | GLFW_JOYSTICK_HAT_BUTTONS 0x00050001
| Joystick hat buttons init hint.
#define | GLFW_COCOA_CHDIR_RESOURCES 0x00051001
| macOS specific init hint.
#define | GLFW_COCOA_MENUBAR 0x00051002
| macOS specific init hint.
#define | GLFW_WAYLAND_LIBDECOR 0x00053001
| Wayland specific init hint.

## Typedefs
typedef void(* | GLFWerrorfun) (int error_code, const char *description)
| The function pointer type for error callbacks.

## Functions
int | glfwInit (void)
| Initializes the GLFW library.
void | glfwTerminate (void)
| Terminates the GLFW library.
void | glfwInitHint (int hint, int value)
| Sets the specified init hint to the desired value.
void | glfwGetVersion (int *major, int *minor, int *rev)
| Retrieves the version of the GLFW library.
const char * | glfwGetVersionString (void)
| Returns a string describing the compile-time configuration.
int | glfwGetError (const char **description)
| Returns and clears the last error for the calling thread.
GLFWerrorfun | glfwSetErrorCallback (GLFWerrorfun callback)
| Sets the error callback.

## Macro Definition Documentation

## ◆ GLFW_VERSION_MAJOR

#define GLFW_VERSION_MAJOR 3

The major version number of the GLFW header. This is incremented when the API is changed in non-compatible ways.

## ◆ GLFW_VERSION_MINOR

#define GLFW_VERSION_MINOR 3

The minor version number of the GLFW header. This is incremented when features are added to the API but it remains backward-compatible.

## ◆ GLFW_VERSION_REVISION

#define GLFW_VERSION_REVISION 9

The revision number of the GLFW header. This is incremented when a bug fix release is made that does not contain any API changes.

## ◆ GLFW_TRUE

#define GLFW_TRUE 1

This is only semantic sugar for the number 1. You can instead use `1` or `true` or `_True` or `GL_TRUE` or `VK_TRUE` or anything else that is equal to one.

## ◆ GLFW_FALSE

#define GLFW_FALSE 0

This is only semantic sugar for the number 0. You can instead use `0` or `false` or `_False` or `GL_FALSE` or `VK_FALSE` or anything else that is equal to zero.

## ◆ GLFW_JOYSTICK_HAT_BUTTONS

#define GLFW_JOYSTICK_HAT_BUTTONS 0x00050001

Joystick hat buttons init hint.

## ◆ GLFW_COCOA_CHDIR_RESOURCES

#define GLFW_COCOA_CHDIR_RESOURCES 0x00051001

macOS specific init hint.

## ◆ GLFW_COCOA_MENUBAR

#define GLFW_COCOA_MENUBAR 0x00051002

macOS specific init hint.

## ◆ GLFW_WAYLAND_LIBDECOR

#define GLFW_WAYLAND_LIBDECOR 0x00053001

Wayland specific init hint.

## Typedef Documentation

## ◆ GLFWerrorfun

typedef void(* GLFWerrorfun) (int error_code, const char *description)

This is the function pointer type for error callbacks. An error callback function has the following signature:

void callback_name(int error_code, const char* description)

Parameters

  [in] | error_code | An error code. Future releases may add more error codes.
  [in] | description | A UTF-8 encoded string describing the error.

Pointer lifetime
  The error description string is valid until the callback function returns.

See also
  Error handling
  glfwSetErrorCallback

Since
  Added in version 3.0.

## Function Documentation

## ◆ glfwInit()

int glfwInit | ( | void |  | ) |

This function initializes the GLFW library. Before most GLFW functions can be used, GLFW must be initialized, and before an application terminates GLFW should be terminated in order to free any resources allocated during or after initialization.

If this function fails, it calls glfwTerminate before returning. If it succeeds, you should call glfwTerminate before the application exits.

Additional calls to this function after successful initialization but before termination will return `GLFW_TRUE` immediately.

Returns
  `GLFW_TRUE` if successful, or `GLFW_FALSE` if an error occurred.

Errors
  Possible errors include GLFW_PLATFORM_ERROR.

Remarks
  macOS: This function will change the current directory of the application to the `Contents/Resources` subdirectory of the application's bundle, if present. This can be disabled with the GLFW_COCOA_CHDIR_RESOURCES init hint.
  X11: This function will set the `LC_CTYPE` category of the application locale according to the current environment if that category is still "C". This is because the "C" locale breaks Unicode text input.

Thread safety
  This function must only be called from the main thread.

See also
  Initialization and termination
  glfwTerminate

Since
  Added in version 1.0.

## ◆ glfwTerminate()

void glfwTerminate | ( | void |  | ) |

This function destroys all remaining windows and cursors, restores any modified gamma ramps and frees any other allocated resources. Once this function is called, you must again call glfwInit successfully before you will be able to use most GLFW functions.

If GLFW has been successfully initialized, this function should be called before the application exits. If initialization fails, there is no need to call this function, as it is called by glfwInit before it returns failure.

This function has no effect if GLFW is not initialized.

Errors
  Possible errors include GLFW_PLATFORM_ERROR.

Remarks
  This function may be called before glfwInit.

Warning
  The contexts of any remaining windows must not be current on any other thread when this function is called.

Reentrancy
  This function must not be called from a callback.

Thread safety
  This function must only be called from the main thread.

See also
  Initialization and termination
  glfwInit

Since
  Added in version 1.0.

## ◆ glfwInitHint()

void glfwInitHint | ( | int | hint,
|  | int | value
| ) |  |

This function sets hints for the next initialization of GLFW.

The values you set hints to are never reset by GLFW, but they only take effect during initialization. Once GLFW has been initialized, any values you set will be ignored until the library is terminated and initialized again.

Some hints are platform specific. These may be set on any platform but they will only affect their specific platform. Other platforms will ignore them. Setting these hints requires no platform specific headers or functions.

Parameters

  [in] | hint | The init hint to set.
  [in] | value | The new value of the init hint.

Errors
  Possible errors include GLFW_INVALID_ENUM and GLFW_INVALID_VALUE.

Remarks
  This function may be called before glfwInit.

Thread safety
  This function must only be called from the main thread.

See also
  init_hints
  glfwInit

Since
  Added in version 3.3.

## ◆ glfwGetVersion()

void glfwGetVersion | ( | int * | major,
|  | int * | minor,
|  | int * | rev
| ) |  |

This function retrieves the major, minor and revision numbers of the GLFW library. It is intended for when you are using GLFW as a shared library and want to ensure that you are using the minimum required version.

Any or all of the version arguments may be `NULL`.

Parameters

  [out] | major | Where to store the major version number, or `NULL`.
  [out] | minor | Where to store the minor version number, or `NULL`.
  [out] | rev | Where to store the revision number, or `NULL`.

Errors
  None.

Remarks
  This function may be called before glfwInit.

Thread safety
  This function may be called from any thread.

See also
  Version management
  glfwGetVersionString

Since
  Added in version 1.0.

## ◆ glfwGetVersionString()

const char * glfwGetVersionString | ( | void |  | ) |

This function returns the compile-time generated version string of the GLFW library binary. It describes the version, platform, compiler and any platform-specific compile-time options. It should not be confused with the OpenGL or OpenGL ES version string, queried with `glGetString`.

Do not use the version string to parse the GLFW library version. The glfwGetVersion function provides the version of the running library binary in numerical format.

Returns
  The ASCII encoded GLFW version string.

Errors
  None.

Remarks
  This function may be called before glfwInit.

Pointer lifetime
  The returned string is static and compile-time generated.

Thread safety
  This function may be called from any thread.

See also
  Version management
  glfwGetVersion

Since
  Added in version 3.0.

## ◆ glfwGetError()

int glfwGetError | ( | const char ** | description | ) |

This function returns and clears the error code of the last error that occurred on the calling thread, and optionally a UTF-8 encoded human-readable description of it. If no error has occurred since the last call, it returns GLFW_NO_ERROR (zero) and the description pointer is set to `NULL`.

Parameters

  [in] | description | Where to store the error description pointer, or `NULL`.

Returns
  The last error code for the calling thread, or GLFW_NO_ERROR (zero).

Errors
  None.

Pointer lifetime
  The returned string is allocated and freed by GLFW. You should not free it yourself. It is guaranteed to be valid only until the next error occurs or the library is terminated.

Remarks
  This function may be called before glfwInit.

Thread safety
  This function may be called from any thread.

See also
  Error handling
  glfwSetErrorCallback

Since
  Added in version 3.3.

## ◆ glfwSetErrorCallback()

GLFWerrorfun glfwSetErrorCallback | ( | GLFWerrorfun | callback | ) |

This function sets the error callback, which is called with an error code and a human-readable description each time a GLFW error occurs.

The error code is set before the callback is called. Calling glfwGetError from the error callback will return the same value as the error code argument.

The error callback is called on the thread where the error occurred. If you are using GLFW from multiple threads, your error callback needs to be written accordingly.

Because the description string may have been generated specifically for that error, it is not guaranteed to be valid after the callback has returned. If you wish to use it after the callback returns, you need to make a copy.

Once set, the error callback remains set even after the library has been terminated.

Parameters

  [in] | callback | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set.

Callback signature
  void callback_name(int error_code, const char* description)
  For more information about the callback parameters, see the callback pointer type.

Errors
  None.

Remarks
  This function may be called before glfwInit.

Thread safety
  This function must only be called from the main thread.

See also
  Error handling
  glfwGetError

Since
  Added in version 3.0.